import * as tslib_1 from "tslib";
var Archer = /** @class */ (function () {
    function Archer() {
        var _this = this;
        // 是否处于预加载状态
        this.isPrefetch = false;
        this.prefetchQueue = []; // svg预加载队列
        // 图标名称 -> 资源地址映射
        this.config = {};
        // 内存缓存svg
        this.svgCaches = {};
        // 并发下载数
        this.threadNum = 2;
        this.set = function (config) {
            _this.config = config;
        };
        this.add = function (config) {
            var oldKeys = Object.keys(_this.config);
            var newKeys = Object.keys(config);
            var repeatKeys = [];
            oldKeys.forEach(function (key) {
                if (newKeys.indexOf(key) !== -1) {
                    repeatKeys.push(key);
                }
            });
            if (repeatKeys.length) {
                var names = repeatKeys.join(', ');
                throw (new Error(names + " have been set, please rename!"));
            }
            _this.config = Object.assign({}, _this.config, config);
        };
        // 开启预下载  一般配置在onload后
        this.startPreFetch = function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var keys;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.isPrefetch) {
                            throw (new Error('prefetching!'));
                        }
                        this.isPrefetch = true;
                        keys = Object.keys(this.config);
                        if (!(keys.length === 0)) return [3 /*break*/, 1];
                        this.isPrefetch = false;
                        return [3 /*break*/, 3];
                    case 1:
                        this.prefetchQueue = keys;
                        return [4 /*yield*/, this.popQueue()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/, true];
                }
            });
        }); };
        // 下载svg
        this.fetchSvg = function (url) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, new Promise(function (r) {
                            if (url in _this.svgCaches) {
                                r(_this.svgCaches[url]);
                                return;
                            }
                            var xhr = new XMLHttpRequest();
                            xhr.open('GET', url);
                            xhr.send();
                            xhr.onreadystatechange = function () {
                                if (xhr.readyState == 4 && xhr.status == 200) {
                                    var svg = xhr.responseText;
                                    _this.svgCaches[url] = svg;
                                    r(xhr.responseText);
                                }
                                else if (xhr.readyState == 4 && xhr.status !== 200) {
                                    r('');
                                }
                            };
                        })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        // svg下载队列队列 - 出队
        this.popQueue = function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var temp;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.prefetchQueue.length === 0) {
                            this.isPrefetch = false;
                            return [2 /*return*/];
                        }
                        temp = this.prefetchQueue.splice(0, this.threadNum);
                        return [4 /*yield*/, Promise.all(temp.map(this.downloadSvg))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.popQueue()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, true];
                }
            });
        }); };
        // 下载单个svg
        this.downloadSvg = function (name) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var url;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this.config[name];
                        if (!url) {
                            throw (new Error("svg " + name + " does not exist"));
                        }
                        return [4 /*yield*/, this.fetchSvg(url)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        // 修改并发下载数
        this.setThreadNum = function (num) {
            _this.threadNum = num;
        };
    }
    return Archer;
}());
export default Archer;
//# sourceMappingURL=Archer.js.map